#/bin/bash

cat > .test.h << EOF
#include <set>
#include <poppler/OutputDev.h>
#include <poppler/CairoOutputDev.h>
EOF


BASEDIR=$(dirname $0)
CONF=$BASEDIR/conf.h

echo '// autogenerated by workaround.sh' > ${CONF}


#if gcc -E .test.h
if test -e /usr/include/poppler/CairoOutputDev.h
	then
		echo "workaround.sh: CairoOutputDev.h found"
		echo '#define HAVE_POPPLER_CAIRO_OUTPUT_DEV 1' >> ${CONF}
	else 
		echo "workaround.sh: CairoOutputDev.h not found, use our version, which may not match your installed Poppler Version!"
		echo '#ifdef HAVE_POPPLER_CAIRO_OUTPUT_DEV' >> ${CONF}
		echo '# undef HAVE_POPPLER_CAIRO_OUTPUT_DEV' >> ${CONF}
		echo '#endif' >> ${CONF}
	fi
 	
